/* sc_strings.h
 * SommerCampus 2006
 * CStrings Kurs - Beispiel Bibliothek
 * Diese Bibliothek soll nur als Beispiel dienen und
 * versucht deshalb die GString Klasse der Glib Bibliothek (http://www.gtk.org/api/2.6/glib/glib-Strings.html)
 * zu kopieren/nachzumachen (nicht vollstndig)
 *
 * Licence: GPL-2 */

#ifndef SC_STRINGS_H
#define SC_STRINGS_H

/* Inkludiere string.h, stdlib.h. Nutzer unserer Bibliothek brauchen diese Dateien
 * nicht mehr selber zu inkludieren */

#include <string.h>
#include <stdlib.h>

typedef struct {
	char *str; /* Zeiger auf die dyn. Zeichenkette */
	size_t len; /* Lnge der Zeichenkette */
	size_t size; /* Anzahl Bytes, die bereits reserviert sind */
} sc_strings;

sc_strings *sc_strings_new(const char *init);

/* erzeugt ein neues sc_strings Objekt (dynamisch) mit der Zeichenkette init.
 * Wenn es keinen freien Speicher gibt, dann liefert sie NULL zurck.
 * init muss 0-terminierend sein und init != NULL */

char *sc_strings_free(sc_strings *string, int content);

/* gibt den fr das sc_string Objekt reservierten Speicher zurck.
 * Wenn content 0 ist, dann wird den Speicher fr die Zeichenkette
 * ebenfalls freigegeben und NULL ist zurckgeliefert.
 * 
 * Wenn content != 0 ist, dann wird nur den Speicher fr das sc_string Objekt
 * freigegeben, den fr die Zeichenkette nicht und einen Zeiger auf diese Zeichenkette
 * wird zurckgeliefert (muss von Hand freigegeben werden) */

#endif
